/* hslider_simple_example.c  -  GiwHSlider simple example
Copyright (C) 2006  Alexandre Pereira Bueno, Eduardo Parente Ribeiro

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA

Maintainers
Alexandre Pereira Bueno - alpebu@yahoo.com.br 
James Scott Jr <skoona@users.sourceforge.net>
*/

#include <gtk/gtk.h>
#include <giwhslider.h> 

GtkWidget *window;
GtkWidget *vbox;
GtkWidget *hslider;
GtkWidget *label;

int main (int argc, char *argv[])
{
	gtk_init (&argc, &argv);

	// Creating the main window, to hold the hslider
	window = gtk_window_new (GTK_WINDOW_TOPLEVEL);

	gtk_window_set_title(GTK_WINDOW(window), "GiwHSlider Simple Example");
    
	gtk_signal_connect (GTK_OBJECT (window), "destroy", GTK_SIGNAL_FUNC (gtk_exit), NULL);
  	
	// Creating the box to hold the widgets
	vbox=gtk_vbox_new(FALSE, 0);
	gtk_container_add(GTK_CONTAINER(window), vbox);
	gtk_widget_show(vbox);
	
	// Creating the hslider with a function (giw_hslider_new_with_adjustment) wich doesn't need a adjustment
	hslider = giw_hslider_new_with_adjustment(50, 0, 100);
	gtk_box_pack_start(GTK_BOX(vbox), hslider, TRUE, FALSE, 0);
	gtk_widget_show (hslider);

	label=gtk_label_new("Click over the button\n     and drag it.    ");
	gtk_box_pack_start(GTK_BOX(vbox), label, TRUE, FALSE, 0);
	gtk_widget_show (label);
	  
	gtk_widget_show (window);
    
	gtk_main ();
  
	return 0;
}
