/* show_simple_example.c  -  GiwShow widget's simple example
Copyright (C) 2006  Alexandre Pereira Bueno, Eduardo Parente Ribeiro

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA

Maintainers
Alexandre Pereira Bueno - alpebu@yahoo.com.br 
James Scott Jr <skoona@users.sourceforge.net>
*/

#include <gtk/gtk.h>
#include <giwshow.h> 

GtkWidget *window;
GtkWidget *show;

int main (int argc, char *argv[])
{
	gtk_init (&argc, &argv);

	// Creating the window that will hold the show
	window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  
	gtk_window_set_title (GTK_WINDOW (window), "Show");
  
	gtk_signal_connect (GTK_OBJECT (window), "destroy", GTK_SIGNAL_FUNC (gtk_exit), NULL);
  
	gtk_container_border_width (GTK_CONTAINER (window), 10);
  
	// Creating the show, with a function (giw_show_new_with_adjusment) wich doesn't need a adjustment
	show = giw_show_new_with_adjusment(100.0, 100.0, 200.0);
	gtk_container_add(GTK_CONTAINER(window), show);
	gtk_widget_show (show);
		
	gtk_widget_show (window);
	
	gtk_main ();
  
	return(0);
}
