/* tank_simple_example.c  -  GiwTank simple example
Copyright (C) 2006  Alexandre Pereira Bueno, Eduardo Parente Ribeiro

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA

Maintainers
Alexandre Pereira Bueno - alpebu@yahoo.com.br 
James Scott Jr <skoona@users.sourceforge.net>
*/

#include <gtk/gtk.h>
#include <giwtank.h> 

GtkWidget *window;
GtkWidget *tank;
GtkAdjustment *adjustment;

gint refresh(gpointer data)
{
	// If the tank is not in the upper value
	if (adjustment->value!=adjustment->upper){
		adjustment->value++;
		gtk_adjustment_value_changed(adjustment);
	}
	else
		adjustment->value=adjustment->lower; // Back to begining
	
	return(TRUE);
}

int main (int argc, char *argv[])
{
	gtk_init (&argc, &argv);

	// Creating the main window, to hold the tank
	window = gtk_window_new (GTK_WINDOW_TOPLEVEL);

	gtk_window_set_title(GTK_WINDOW(window), "GiwTank Simple Example");

	gtk_window_resize(GTK_WINDOW(window), 300, 100);
    
	gtk_signal_connect (GTK_OBJECT (window), "destroy", GTK_SIGNAL_FUNC (gtk_exit), NULL);
  	
	// Creating the tank with a function (giw_tank_new_with_adjustment) wich doesn't need a adjustment
	tank = giw_tank_new_with_adjustment(50, 0, 100);
	gtk_container_add(GTK_CONTAINER(window), tank);
	gtk_widget_show (tank);
	  
	gtk_widget_show (window);
	
	// Getting the adjustment of the tank
	adjustment=giw_tank_get_adjustment(GIW_TANK(tank));
	
	// Start counting, refreshing every second
	g_timeout_add(100, refresh, NULL);
    
	gtk_main ();
  
	return 0;
}
