/* thermo_simple_example.c  -  GiwThermo simple example
Copyright (C) 2006  Alexandre Pereira Bueno, Eduardo Parente Ribeiro

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA

Maintainers
Alexandre Pereira Bueno - alpebu@yahoo.com.br 
James Scott Jr <skoona@users.sourceforge.net>
*/

#include <gtk/gtk.h>
#include <giwthermo.h> 

GtkWidget *window;
GtkWidget *thermo;
GtkAdjustment *adjustment;

gint refresh(gpointer data)
{
	// If the thermo is not in the upper value
	if (adjustment->value!=adjustment->upper){
		adjustment->value++;
		gtk_adjustment_value_changed(adjustment);
	}
	else
		adjustment->value=adjustment->lower; // Back to begining
	
	return(TRUE);
}

int main (int argc, char *argv[])
{
	gtk_init (&argc, &argv);

	// Creating the main window, to hold the thermo
	window = gtk_window_new(GTK_WINDOW_TOPLEVEL);

	gtk_window_set_title(GTK_WINDOW (window), "GiwThermo Simple Example");

	gtk_window_maximize(GTK_WINDOW (window));
    
	gtk_signal_connect(GTK_OBJECT (window), "destroy", GTK_SIGNAL_FUNC (gtk_exit), NULL);
  	
	// Creating the thermo with a function (giw_thermo_new_with_adjustment) wich doesn't need a adjustment
	thermo=giw_thermo_new_with_adjustment(50, 0, 100);
	gtk_container_add(GTK_CONTAINER(window), thermo);
	gtk_widget_show(thermo);
	  
	gtk_widget_show(window);
	
	// Getting the adjustment of the thermo
	adjustment=giw_thermo_get_adjustment(GIW_THERMO(thermo));
	
	// Start counting, refreshing every second
	g_timeout_add(100, refresh, NULL);
    
	gtk_main ();
  
	return 0;
}
