/* xyplot_full_example.c  -  GiwXYPlot widget's full example
Copyright (C) 2006  Alexandre Pereira Bueno, Eduardo Parente Ribeiro

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA

Maintainers
Alexandre Pereira Bueno - alpebu@yahoo.com.br 
James Scott Jr <skoona@users.sourceforge.net>
*/


#include <math.h>
#include <stdlib.h>
#include <gtk/gtk.h>
#include <giwxyplot.h> 

GtkWidget *window;
GtkWidget *table1;

GtkWidget *frame_xyplot;
GtkWidget *xyplot;

GtkWidget *frame_get_time;
GtkWidget *vbox_get_time;
GtkWidget *label_time;
GtkWidget *button_get_time;

GtkWidget *frame_set_ticks;
GtkWidget *hbox_set_ticks;
GtkWidget *label_hminor;
GtkWidget *spin_hminor;
GtkWidget *label_hmajor;
GtkWidget *spin_hmajor;
GtkWidget *label_vminor;
GtkWidget *spin_vminor;
GtkWidget *label_vmajor;
GtkWidget *spin_vmajor;

GtkWidget *frame_set_grids;
GtkWidget *vbox_set_grids;
GtkWidget *toggle_h_ma_grids;
GtkWidget *toggle_h_mi_grids;
GtkWidget *toggle_v_ma_grids;
GtkWidget *toggle_v_mi_grids;

GtkWidget *frame_set_data;
GtkWidget *vbox_set_data;
GtkWidget *toggle_data1;
GtkWidget *toggle_data2;
GtkWidget *toggle_data3;
GtkWidget *toggle_data4;

GtkWidget *frame_position;
GtkWidget *vbox_position;
GtkWidget *label_x;
GtkWidget *label_y;

GtkWidget *frame_set_l_digits;
GtkWidget *spin_l_digits;

GtkWidget *frame_configure_mouse;
GtkWidget *vbox_configure_mouse;
GtkWidget *label_mouse_zoom;
GtkWidget *combobox_mouse_zoom;
GtkWidget *label_mouse_displace;
GtkWidget *combobox_mouse_displace;
GtkWidget *label_mouse_autorange;
GtkWidget *combobox_mouse_autorange;
GtkWidget *toggle_wheel;
GtkWidget *label_wheel;
GtkWidget *spin_wheel;

GtkWidget *statusbar;

XYPlotData data1, data2, data3, data4;	

int hmajor, hminor, vmajor, vminor;

void spin_hminor_changed_value(GtkSpinButton *spinbutton, gpointer user_data)
{
	hminor=gtk_spin_button_get_value(spinbutton);
	giw_xyplot_set_ticks(GIW_XYPLOT(xyplot), hmajor, hminor, vmajor, vminor);	
}

void spin_hmajor_changed_value(GtkSpinButton *spinbutton, gpointer user_data)
{
	hmajor=gtk_spin_button_get_value(spinbutton);
	giw_xyplot_set_ticks(GIW_XYPLOT(xyplot), hmajor, hminor, vmajor, vminor);	
}

void spin_vminor_changed_value(GtkSpinButton *spinbutton, gpointer user_data)
{
	vminor=gtk_spin_button_get_value(spinbutton);
	giw_xyplot_set_ticks(GIW_XYPLOT(xyplot), hmajor, hminor, vmajor, vminor);	
}

void spin_vmajor_changed_value(GtkSpinButton *spinbutton, gpointer user_data)
{
	vmajor=gtk_spin_button_get_value(spinbutton);
	giw_xyplot_set_ticks(GIW_XYPLOT(xyplot), hmajor, hminor, vmajor, vminor);	
}

void toggle_h_ma_grids_toggled(GtkToggleButton *togglebutton, gpointer user_data)
{
	giw_xyplot_enable_grids (GIW_XYPLOT(xyplot), GIW_XYPLOT_HMAJOR_GRID, gtk_toggle_button_get_active(togglebutton));
}

void toggle_h_mi_grids_toggled(GtkToggleButton *togglebutton, gpointer user_data)
{
	giw_xyplot_enable_grids (GIW_XYPLOT(xyplot), GIW_XYPLOT_HMINOR_GRID, gtk_toggle_button_get_active(togglebutton));
}

void toggle_v_ma_grids_toggled(GtkToggleButton *togglebutton, gpointer user_data)
{
	giw_xyplot_enable_grids (GIW_XYPLOT(xyplot), GIW_XYPLOT_VMAJOR_GRID, gtk_toggle_button_get_active(togglebutton));
}

void toggle_v_mi_grids_toggled(GtkToggleButton *togglebutton, gpointer user_data)
{
	giw_xyplot_enable_grids (GIW_XYPLOT(xyplot), GIW_XYPLOT_VMINOR_GRID, gtk_toggle_button_get_active(togglebutton));
}

void toggle_data1_toggled(GtkToggleButton *togglebutton, gpointer user_data)
{
	if (gtk_toggle_button_get_active(togglebutton))
		giw_xyplot_add_data(GIW_XYPLOT(xyplot), &data1);
	else
		giw_xyplot_remove_data(GIW_XYPLOT(xyplot), &data1);

	gtk_widget_queue_draw(GTK_WIDGET(xyplot));  
}

void toggle_data2_toggled(GtkToggleButton *togglebutton, gpointer user_data)
{
	if (gtk_toggle_button_get_active(togglebutton))
		giw_xyplot_add_data(GIW_XYPLOT(xyplot), &data2);
	else
		giw_xyplot_remove_data(GIW_XYPLOT(xyplot), &data2);

	gtk_widget_queue_draw(GTK_WIDGET(xyplot));  
}

void toggle_data3_toggled(GtkToggleButton *togglebutton, gpointer user_data)
{
	if (gtk_toggle_button_get_active(togglebutton))
		giw_xyplot_add_data(GIW_XYPLOT(xyplot), &data3);
	else
		giw_xyplot_remove_data(GIW_XYPLOT(xyplot), &data3);

	gtk_widget_queue_draw(GTK_WIDGET(xyplot));  
}

void toggle_data4_toggled(GtkToggleButton *togglebutton, gpointer user_data)
{
	if (gtk_toggle_button_get_active(togglebutton))
		giw_xyplot_add_data(GIW_XYPLOT(xyplot), &data4);
	else
 		giw_xyplot_remove_data(GIW_XYPLOT(xyplot), &data4);

	gtk_widget_queue_draw(GTK_WIDGET(xyplot));  
}

void spin_l_digits_changed_value(GtkSpinButton *spinbutton, gpointer user_data)
{
	giw_xyplot_set_legends_digits(GIW_XYPLOT(xyplot), gtk_spin_button_get_value(spinbutton));
}

void combobox_mouse_zoom_changed (GtkComboBox *widget, gpointer user_data)
{
	int active;
	
	active=gtk_combo_box_get_active(widget);

	switch (active){
	case 0:
		giw_xyplot_configure_mouse_zoom(GIW_XYPLOT(xyplot), FALSE, 0);
	break;
	case 1:
		giw_xyplot_configure_mouse_zoom(GIW_XYPLOT(xyplot), TRUE, 1);
	break;
	case 2:
		giw_xyplot_configure_mouse_zoom(GIW_XYPLOT(xyplot), TRUE, 2);
	break;
	case 3:
		giw_xyplot_configure_mouse_zoom(GIW_XYPLOT(xyplot), TRUE, 3);
	break;
	}
}

void combobox_mouse_displace_changed (GtkComboBox *widget, gpointer user_data)
{
	int active;
	
	active=gtk_combo_box_get_active(widget);

	switch (active){
	case 0:
		giw_xyplot_configure_mouse_displace(GIW_XYPLOT(xyplot), FALSE, 0);
	break;
	case 1:
		giw_xyplot_configure_mouse_displace(GIW_XYPLOT(xyplot), TRUE, 1);
	break;
	case 2:
		giw_xyplot_configure_mouse_displace(GIW_XYPLOT(xyplot), TRUE, 2);
	break;
	case 3:
		giw_xyplot_configure_mouse_displace(GIW_XYPLOT(xyplot), TRUE, 3);
	break;
	}
}

void combobox_mouse_autorange_changed (GtkComboBox *widget, gpointer user_data)
{
	int active;
	
	active=gtk_combo_box_get_active(widget);

	switch (active){
	case 0:
		giw_xyplot_configure_mouse_autorange(GIW_XYPLOT(xyplot), FALSE, 0);
	break;
	case 1:
		giw_xyplot_configure_mouse_autorange(GIW_XYPLOT(xyplot), TRUE, 1);
	break;
	case 2:
		giw_xyplot_configure_mouse_autorange(GIW_XYPLOT(xyplot), TRUE, 2);
	break;
	case 3:
		giw_xyplot_configure_mouse_autorange(GIW_XYPLOT(xyplot), TRUE, 3);
	break;
	}
}

void toggle_wheel_toggled(GtkToggleButton *togglebutton, gpointer user_data)
{
	giw_xyplot_configure_wheel_zoom(GIW_XYPLOT(xyplot), gtk_toggle_button_get_active(togglebutton), gtk_spin_button_get_value(GTK_SPIN_BUTTON(spin_wheel)));
}

void spin_wheel_changed_value(GtkSpinButton *spinbutton, gpointer user_data)
{
	giw_xyplot_configure_wheel_zoom(GIW_XYPLOT(xyplot), gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(toggle_wheel)), gtk_spin_button_get_value(spinbutton));
}


gboolean xyplot_motion_notify_event(GtkWidget *widget, GdkEventMotion *event, gpointer user_data)
{
	double xv, yv;
	int x, y;
	char str[50];
	int context_id;

	x=event->x;
	y=event->y;

	if (event->is_hint || (event->window != widget->window))
		gdk_window_get_pointer (widget->window, &x, &y, NULL);

	giw_xyplot_get_point(GIW_XYPLOT(xyplot), x, y, &xv, &yv);
	snprintf(str, 50, "Mouse position: %f, %f", xv, yv);
	context_id=gtk_statusbar_get_context_id (GTK_STATUSBAR(statusbar), "mouse position");
	gtk_statusbar_push (GTK_STATUSBAR(statusbar), context_id, str);
    
    return TRUE;
}

int main (int argc, char *argv[])
{
	int loop;
	
	gtk_init (&argc, &argv);

	window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  
	gtk_window_set_title (GTK_WINDOW (window), "GiwXYPlot Full Example");
  
	gtk_signal_connect (GTK_OBJECT (window), "destroy", GTK_SIGNAL_FUNC (gtk_exit), NULL);
  
	gtk_container_border_width (GTK_CONTAINER (window), 10);
	
	// Table with to hold all the frames
	table1=gtk_table_new(4, 3, FALSE);
	gtk_container_add(GTK_CONTAINER(window), table1);
	gtk_widget_show(table1);
  
	// The frame with the xyplot and the label to view time
	frame_xyplot=gtk_frame_new("XYPlot:");
	gtk_table_attach(GTK_TABLE(table1), frame_xyplot, 0, 1, 0, 2, GTK_EXPAND | GTK_FILL, GTK_EXPAND | GTK_FILL, 0, 0);
	gtk_widget_show(frame_xyplot);
  
	xyplot=giw_xyplot_new();
	gtk_container_add(GTK_CONTAINER(frame_xyplot), xyplot);
	gtk_widget_show (xyplot);

	// Frame with the labels and spins to set the ticks
	frame_set_ticks=gtk_frame_new("Set ticks:");
	gtk_table_attach(GTK_TABLE(table1), frame_set_ticks, 0, 1, 2, 3, GTK_FILL, GTK_FILL, 0, 0);
	gtk_widget_show(frame_set_ticks);

	hbox_set_ticks=gtk_hbox_new(FALSE, 0);
	gtk_container_add(GTK_CONTAINER(frame_set_ticks), hbox_set_ticks);
	gtk_widget_show(hbox_set_ticks);

	label_hminor=gtk_label_new("H Minor: ");
	gtk_box_pack_start(GTK_BOX(hbox_set_ticks), label_hminor, TRUE, FALSE, 0);
	gtk_widget_show(label_hminor); 
	
	spin_hminor=gtk_spin_button_new_with_range(0, 30, 1);
	gtk_box_pack_start(GTK_BOX(hbox_set_ticks), spin_hminor, TRUE, FALSE, 0);
	gtk_widget_show(spin_hminor);

	label_hmajor=gtk_label_new("H Major: ");
	gtk_box_pack_start(GTK_BOX(hbox_set_ticks), label_hmajor, TRUE, FALSE, 0);
	gtk_widget_show(label_hmajor); 
	
	spin_hmajor=gtk_spin_button_new_with_range(0, 30, 1);
	gtk_box_pack_start(GTK_BOX(hbox_set_ticks), spin_hmajor, TRUE, FALSE, 0);
	gtk_widget_show(spin_hmajor);

	label_vminor=gtk_label_new("V Minor: ");
	gtk_box_pack_start(GTK_BOX(hbox_set_ticks), label_vminor, TRUE, FALSE, 0);
	gtk_widget_show(label_vminor); 
	
	spin_vminor=gtk_spin_button_new_with_range(0, 30, 1);
	gtk_box_pack_start(GTK_BOX(hbox_set_ticks), spin_vminor, TRUE, FALSE, 0);
	gtk_widget_show(spin_vminor);

	label_vmajor=gtk_label_new("V Major: ");
	gtk_box_pack_start(GTK_BOX(hbox_set_ticks), label_vmajor, TRUE, FALSE, 0);
	gtk_widget_show(label_vmajor); 
	
	spin_vmajor=gtk_spin_button_new_with_range(0, 30, 1);
	gtk_box_pack_start(GTK_BOX(hbox_set_ticks), spin_vmajor, TRUE, FALSE, 0);
	gtk_widget_show(spin_vmajor);

	// Frame with the buttons to set the grids
	frame_set_grids=gtk_frame_new("Set grids:");
	gtk_table_attach(GTK_TABLE(table1), frame_set_grids, 1, 2, 0, 1, GTK_FILL, GTK_FILL, 0, 0);
	gtk_widget_show(frame_set_grids);

	vbox_set_grids=gtk_vbox_new(FALSE, 0);
	gtk_container_add(GTK_CONTAINER(frame_set_grids), vbox_set_grids);
	gtk_widget_show(vbox_set_grids);

	toggle_h_ma_grids=gtk_toggle_button_new_with_label("Horizontal Major");
	gtk_box_pack_start(GTK_BOX(vbox_set_grids), toggle_h_ma_grids, TRUE, FALSE, 0);
	gtk_widget_show(toggle_h_ma_grids);

	toggle_h_mi_grids=gtk_toggle_button_new_with_label("Horizontal Minor");
	gtk_box_pack_start(GTK_BOX(vbox_set_grids), toggle_h_mi_grids, TRUE, FALSE, 0);
	gtk_widget_show(toggle_h_mi_grids);

	toggle_v_ma_grids=gtk_toggle_button_new_with_label("Vertical Major");
	gtk_box_pack_start(GTK_BOX(vbox_set_grids), toggle_v_ma_grids, TRUE, FALSE, 0);
	gtk_widget_show(toggle_v_ma_grids);

	toggle_v_mi_grids=gtk_toggle_button_new_with_label("Vertical Minor");
	gtk_box_pack_start(GTK_BOX(vbox_set_grids), toggle_v_mi_grids, TRUE, FALSE, 0);
	gtk_widget_show(toggle_v_mi_grids);

	// Frame to hold the spin buttons that sets the data
	frame_set_data=gtk_frame_new("Set data:");
	gtk_table_attach(GTK_TABLE(table1), frame_set_data, 1, 2, 1, 2, GTK_FILL, GTK_FILL, 0, 0);
	gtk_widget_show(frame_set_data);

	vbox_set_data=gtk_vbox_new(FALSE, 0);
	gtk_container_add(GTK_CONTAINER(frame_set_data), vbox_set_data);
	gtk_widget_show(vbox_set_data);

	toggle_data1=gtk_toggle_button_new_with_label("Data 1");
	gtk_box_pack_start(GTK_BOX(vbox_set_data), toggle_data1, TRUE, FALSE, 0);
	gtk_widget_show(toggle_data1);
	
	toggle_data2=gtk_toggle_button_new_with_label("Data 2");
	gtk_box_pack_start(GTK_BOX(vbox_set_data), toggle_data2, TRUE, FALSE, 0);
	gtk_widget_show(toggle_data2);

	toggle_data3=gtk_toggle_button_new_with_label("Data 3");
	gtk_box_pack_start(GTK_BOX(vbox_set_data), toggle_data3, TRUE, FALSE, 0);
	gtk_widget_show(toggle_data3);

	toggle_data4=gtk_toggle_button_new_with_label("Data 4");
	gtk_box_pack_start(GTK_BOX(vbox_set_data), toggle_data4, TRUE, FALSE, 0);
	gtk_widget_show(toggle_data4);

	// Frame to hold the spin button that sets the legends digits
	frame_set_l_digits=gtk_frame_new("Set legends digits:");
	gtk_table_attach(GTK_TABLE(table1), frame_set_l_digits, 1, 2, 2, 3, GTK_FILL | GTK_FILL, GTK_FILL | GTK_FILL, 0, 0);
	gtk_widget_show(frame_set_l_digits);

	spin_l_digits = gtk_spin_button_new_with_range(0, 30, 1);
	gtk_container_add(GTK_CONTAINER(frame_set_l_digits), spin_l_digits);
	gtk_widget_show (spin_l_digits);

	// Frame to hold widgets to configre the mouse
	frame_configure_mouse=gtk_frame_new("Configure Mouse:");
	gtk_table_attach(GTK_TABLE(table1), frame_configure_mouse, 2, 3, 0, 3, GTK_FILL | GTK_FILL, GTK_FILL | GTK_FILL, 0, 0);
	gtk_widget_show(frame_configure_mouse);

	vbox_configure_mouse=gtk_vbox_new(FALSE, 0);
	gtk_container_add(GTK_CONTAINER(frame_configure_mouse), vbox_configure_mouse);
	gtk_widget_show(vbox_configure_mouse);

	label_mouse_zoom=gtk_label_new("Mouse Zoom:");
	gtk_box_pack_start(GTK_BOX(vbox_configure_mouse), label_mouse_zoom, TRUE, FALSE, 0);
	gtk_widget_show(label_mouse_zoom);
 	
 	combobox_mouse_zoom=gtk_combo_box_new_text();
	gtk_box_pack_start(GTK_BOX(vbox_configure_mouse), combobox_mouse_zoom, TRUE, FALSE, 0);
	gtk_widget_show(combobox_mouse_zoom);

	label_mouse_displace=gtk_label_new("Mouse Displace:");
	gtk_box_pack_start(GTK_BOX(vbox_configure_mouse), label_mouse_displace, TRUE, FALSE, 0);
	gtk_widget_show(label_mouse_displace);
	
	combobox_mouse_displace=gtk_combo_box_new_text();
	gtk_box_pack_start(GTK_BOX(vbox_configure_mouse), combobox_mouse_displace, TRUE, FALSE, 0);
	gtk_widget_show(combobox_mouse_displace);

	label_mouse_autorange=gtk_label_new("Mouse Autorange:");
	gtk_box_pack_start(GTK_BOX(vbox_configure_mouse), label_mouse_autorange, TRUE, FALSE, 0);
	gtk_widget_show(label_mouse_autorange);

	combobox_mouse_autorange=gtk_combo_box_new_text();
	gtk_box_pack_start(GTK_BOX(vbox_configure_mouse), combobox_mouse_autorange, TRUE, FALSE, 0);
	gtk_widget_show(combobox_mouse_autorange);

	toggle_wheel=gtk_toggle_button_new_with_label("Enable Wheel Zoom");
	gtk_box_pack_start(GTK_BOX(vbox_configure_mouse), toggle_wheel, TRUE, FALSE, 0);
	gtk_widget_show(toggle_wheel);

	label_wheel=gtk_label_new("Wheel Zoom Factor:");
	gtk_box_pack_start(GTK_BOX(vbox_configure_mouse), label_wheel, TRUE, FALSE, 0);
	gtk_widget_show(label_wheel);

	spin_wheel=gtk_spin_button_new_with_range(0.0, 1.0, 0.01);
	gtk_box_pack_start(GTK_BOX(vbox_configure_mouse), spin_wheel, TRUE, FALSE, 0);
	gtk_widget_show(spin_wheel);	

 	// The satusbars
	statusbar=gtk_statusbar_new();
	gtk_table_attach(GTK_TABLE(table1), statusbar, 0, 3, 3, 4, GTK_FILL, GTK_FILL, 0, 0);
	gtk_widget_show (statusbar);

	// Setting initial values
	hminor=3;
	hmajor=6;
	vminor=3;
	vmajor=11;
	giw_xyplot_set_ticks(GIW_XYPLOT(xyplot), hmajor, hminor, vmajor, vminor);
	gtk_spin_button_set_value(GTK_SPIN_BUTTON(spin_hminor), hminor);
	gtk_spin_button_set_value(GTK_SPIN_BUTTON(spin_hmajor), hmajor);
	gtk_spin_button_set_value(GTK_SPIN_BUTTON(spin_vminor), vminor);
	gtk_spin_button_set_value(GTK_SPIN_BUTTON(spin_vmajor), vmajor);

	// Creating the data1
	data1.x=(double*)malloc(sizeof(double[100]));
	data1.y=(double*)malloc(sizeof(double[100]));
	for (loop=0; loop<100; loop++){
		data1.x[loop]=((double)loop)/20.0;
		data1.y[loop]=sin(data1.x[loop]);
	}

	data1.size=100;
	data1.style=GIW_XYPLOT_DATA_POINTS;
	data1.p_width=4;
	data1.l_width=0;
	data1.p_color.red=0; data1.p_color.green=0; data1.p_color.blue=0;
	data1.l_color.red=0; data1.l_color.green=0; data1.l_color.blue=0;
	data1.line_style=GDK_LINE_SOLID;

	giw_xyplot_add_data(GIW_XYPLOT(xyplot), &data1);    
	
	// Creating the data2
	data2.x=(double*)malloc(sizeof(double[10]));
	data2.y=(double*)malloc(sizeof(double[10]));
	for (loop=0; loop<10; loop++){
		data2.x[loop]=((double)loop)/2.0;
		data2.y[loop]=cos(data2.x[loop]);
	}

	data2.size=10;
	data2.style=GIW_XYPLOT_DATA_LINES_AND_POINTS;
	data2.p_width=6;
	data2.l_width=1;
	data2.p_color.red=65000; data2.p_color.green=0; data2.p_color.blue=0;
	data2.l_color.red=0; data2.l_color.green=0; data2.l_color.blue=65000;
	data2.line_style=GDK_LINE_ON_OFF_DASH;

	giw_xyplot_add_data(GIW_XYPLOT(xyplot), &data2);    

	// Creating the data3
	data3.x=(double*)malloc(sizeof(double[10]));
	data3.y=(double*)malloc(sizeof(double[10]));
	for (loop=0; loop<10; loop++){
		data3.x[loop]=((double)loop)/2.0;
		data3.y[loop]=0;
	}

	data3.size=10;
	data3.style=GIW_XYPLOT_DATA_LINES;
	data3.p_width=0;
	data3.l_width=2;
	data3.p_color.red=0; data3.p_color.green=0; data3.p_color.blue=0;
	data3.l_color.red=0; data3.l_color.green=65000; data3.l_color.blue=0;
 	data3.line_style=GDK_LINE_SOLID;

	giw_xyplot_add_data(GIW_XYPLOT(xyplot), &data3);    	

	// Creating the data4
	data4.x=(double*)malloc(sizeof(double[10]));
	data4.y=(double*)malloc(sizeof(double[10]));
	for (loop=0; loop<10; loop++){
		data4.x[loop]=((double)loop)/2.0;
		data4.y[loop]=-data4.x[loop]/10;
	}

	data4.size=10;
	data4.style=GIW_XYPLOT_DATA_LINES;
	data4.p_width=0;
	data4.l_width=2;
	data4.p_color.red=0; data4.p_color.green=0; data4.p_color.blue=0;
	data4.l_color.red=65000; data4.l_color.green=0; data4.l_color.blue=0;
 	data4.line_style=GDK_LINE_SOLID;

	giw_xyplot_add_data(GIW_XYPLOT(xyplot), &data4); 
	
	giw_xyplot_set_autorange(GIW_XYPLOT(xyplot), NULL);

	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(toggle_h_ma_grids), TRUE);
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(toggle_h_mi_grids), TRUE);
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(toggle_v_ma_grids), TRUE);
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(toggle_v_mi_grids), TRUE);

	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(toggle_data1), TRUE);
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(toggle_data2), TRUE);
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(toggle_data3), TRUE);
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(toggle_data4), TRUE);

	gtk_spin_button_set_value(GTK_SPIN_BUTTON(spin_l_digits), 8);

	gtk_combo_box_append_text (GTK_COMBO_BOX(combobox_mouse_zoom), "Disabled");
	gtk_combo_box_append_text (GTK_COMBO_BOX(combobox_mouse_zoom), "Left Button");
	gtk_combo_box_append_text (GTK_COMBO_BOX(combobox_mouse_zoom), "Middle Button");
	gtk_combo_box_append_text (GTK_COMBO_BOX(combobox_mouse_zoom), "Right Button");
	gtk_combo_box_append_text (GTK_COMBO_BOX(combobox_mouse_displace), "Disabled");
	gtk_combo_box_append_text (GTK_COMBO_BOX(combobox_mouse_displace), "Left Button");
	gtk_combo_box_append_text (GTK_COMBO_BOX(combobox_mouse_displace), "Middle Button");
	gtk_combo_box_append_text (GTK_COMBO_BOX(combobox_mouse_displace), "Right Button");
	gtk_combo_box_append_text (GTK_COMBO_BOX(combobox_mouse_autorange), "Disabled");
	gtk_combo_box_append_text (GTK_COMBO_BOX(combobox_mouse_autorange), "Left Button");
	gtk_combo_box_append_text (GTK_COMBO_BOX(combobox_mouse_autorange), "Middle Button");
	gtk_combo_box_append_text (GTK_COMBO_BOX(combobox_mouse_autorange), "Right Button");

	gtk_combo_box_set_active (GTK_COMBO_BOX(combobox_mouse_zoom), 3);
	gtk_combo_box_set_active (GTK_COMBO_BOX(combobox_mouse_displace), 1);
	gtk_combo_box_set_active (GTK_COMBO_BOX(combobox_mouse_autorange), 2);

	giw_xyplot_configure_mouse_zoom(GIW_XYPLOT(xyplot), TRUE, 3);	
	giw_xyplot_configure_mouse_displace(GIW_XYPLOT(xyplot), TRUE, 1);
	giw_xyplot_configure_mouse_autorange(GIW_XYPLOT(xyplot), TRUE, 2);
	giw_xyplot_configure_wheel_zoom(GIW_XYPLOT(xyplot), TRUE, 0.95);

	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(toggle_wheel), TRUE);
	gtk_spin_button_set_value(GTK_SPIN_BUTTON(spin_wheel), 0.95);

	g_signal_connect(G_OBJECT(spin_hminor), "value-changed", G_CALLBACK(spin_hminor_changed_value), NULL);
	g_signal_connect(G_OBJECT(spin_hmajor), "value-changed", G_CALLBACK(spin_hmajor_changed_value), NULL);
	g_signal_connect(G_OBJECT(spin_vminor), "value-changed", G_CALLBACK(spin_vminor_changed_value), NULL);
	g_signal_connect(G_OBJECT(spin_vmajor), "value-changed", G_CALLBACK(spin_vmajor_changed_value), NULL);

	g_signal_connect(G_OBJECT(toggle_h_ma_grids), "toggled", G_CALLBACK(toggle_h_ma_grids_toggled), NULL);
	g_signal_connect(G_OBJECT(toggle_h_mi_grids), "toggled", G_CALLBACK(toggle_h_mi_grids_toggled), NULL);
	g_signal_connect(G_OBJECT(toggle_v_ma_grids), "toggled", G_CALLBACK(toggle_v_ma_grids_toggled), NULL);
	g_signal_connect(G_OBJECT(toggle_v_mi_grids), "toggled", G_CALLBACK(toggle_v_mi_grids_toggled), NULL);

	g_signal_connect(G_OBJECT(toggle_data1), "toggled", G_CALLBACK(toggle_data1_toggled), NULL);
	g_signal_connect(G_OBJECT(toggle_data2), "toggled", G_CALLBACK(toggle_data2_toggled), NULL);
	g_signal_connect(G_OBJECT(toggle_data3), "toggled", G_CALLBACK(toggle_data3_toggled), NULL);
	g_signal_connect(G_OBJECT(toggle_data4), "toggled", G_CALLBACK(toggle_data4_toggled), NULL);

	g_signal_connect(G_OBJECT(spin_l_digits), "value-changed", G_CALLBACK(spin_l_digits_changed_value), NULL);

	g_signal_connect_after(G_OBJECT(xyplot), "motion-notify-event", G_CALLBACK(xyplot_motion_notify_event), NULL);

	g_signal_connect(G_OBJECT(combobox_mouse_zoom), "changed", G_CALLBACK(combobox_mouse_zoom_changed), NULL);
	g_signal_connect(G_OBJECT(combobox_mouse_displace), "changed", G_CALLBACK(combobox_mouse_displace_changed), NULL);
	g_signal_connect(G_OBJECT(combobox_mouse_autorange), "changed", G_CALLBACK(combobox_mouse_autorange_changed), NULL);
	g_signal_connect(G_OBJECT(toggle_wheel), "toggled", G_CALLBACK(toggle_wheel_toggled), NULL);
	g_signal_connect(G_OBJECT(spin_wheel), "value-changed", G_CALLBACK(spin_wheel_changed_value), NULL);

	gtk_widget_show (window);
  
	gtk_main ();
	
	return 0;
}
